diff --git a/src/include/common/jsonapi.h b/src/include/common/jsonapi.h
index 02943cdad8..66844aefec 100644
--- a/src/include/common/jsonapi.h
+++ b/src/include/common/jsonapi.h
@@ -36,6 +36,7 @@ typedef enum JsonTokenType
 typedef enum JsonParseErrorType
 {
 	JSON_SUCCESS,
+	JSON_INCOMPLETE,
 	JSON_ESCAPING_INVALID,
 	JSON_ESCAPING_REQUIRED,
 	JSON_EXPECTED_ARRAY_FIRST,
@@ -57,6 +58,9 @@ typedef enum JsonParseErrorType
 	JSON_SEM_ACTION_FAILED,		/* error should already be reported */
 } JsonParseErrorType;
 
+/* Parser state private to jsonapi.c */
+typedef struct JsonParserStack JsonParserStack;
+typedef struct JsonIncrementalState JsonIncrementalState;
 
 /*
  * All the fields in this structure should be treated as read-only.
@@ -83,11 +87,14 @@ typedef struct JsonLexContext
 	char	   *token_start;
 	char	   *token_terminator;
 	char	   *prev_token_terminator;
+	bool		incremental;
 	JsonTokenType token_type;
 	int			lex_level;
 	bits32		flags;
 	int			line_number;	/* line number, starting from 1 */
 	char	   *line_start;		/* where that line starts within input */
+	JsonParserStack *pstack;
+	JsonIncrementalState *inc_state;
 	StringInfo	strval;
 } JsonLexContext;
 
@@ -140,6 +147,12 @@ typedef struct JsonSemAction
 extern JsonParseErrorType pg_parse_json(JsonLexContext *lex,
 										JsonSemAction *sem);
 
+extern JsonParseErrorType pg_parse_json_incremental(JsonLexContext *lex,
+													JsonSemAction *sem,
+													char *json,
+													int len,
+													bool is_last);
+
 /* the null action object used for pure validation */
 extern PGDLLIMPORT JsonSemAction nullSemAction;
 
@@ -175,6 +188,16 @@ extern JsonLexContext *makeJsonLexContextCstringLen(JsonLexContext *lex,
 													int len,
 													int encoding,
 													bool need_escapes);
+
+/*
+ * make a JsonLexContext suitable for incremental parsing.
+ * the string chunks will be handed to pg_parse_json_incremental,
+ * so there's no need for them here.
+ */
+extern JsonLexContext *makeJsonLexContextIncremental(JsonLexContext *lex,
+													 int encoding,
+													 bool need_escapes);
+
 extern void freeJsonLexContext(JsonLexContext *lex);
 
 /* lex one token */
diff --git a/src/include/pg_config_manual.h b/src/include/pg_config_manual.h
index a512552182..f941ee2faf 100644
--- a/src/include/pg_config_manual.h
+++ b/src/include/pg_config_manual.h
@@ -240,6 +240,13 @@
  *------------------------------------------------------------------------
  */
 
+/*
+ * Force use of the non-recursive JSON parser in all cases. This is useful
+ * to validate the working of the parser, and the regression tests should
+ * pass except for some different error messages about the stack limit.
+ */
+/* #define FORCE_JSON_PSTACK */
+
 /*
  * Include Valgrind "client requests", mostly in the memory allocator, so
  * Valgrind understands PostgreSQL memory contexts.  This permits detecting
diff --git a/src/test/modules/Makefile b/src/test/modules/Makefile
index 875a76d6f1..0efec0e52e 100644
--- a/src/test/modules/Makefile
+++ b/src/test/modules/Makefile
@@ -22,6 +22,7 @@ SUBDIRS = \
 		  test_extensions \
 		  test_ginpostinglist \
 		  test_integerset \
+		  test_json_parser \
 		  test_lfind \
 		  test_misc \
 		  test_oat_hooks \
diff --git a/src/test/modules/meson.build b/src/test/modules/meson.build
index f1d18a1b29..24a9394a9e 100644
--- a/src/test/modules/meson.build
+++ b/src/test/modules/meson.build
@@ -21,6 +21,7 @@ subdir('test_dsm_registry')
 subdir('test_extensions')
 subdir('test_ginpostinglist')
 subdir('test_integerset')
+subdir('test_json_parser')
 subdir('test_lfind')
 subdir('test_misc')
 subdir('test_oat_hooks')
diff --git a/src/test/modules/test_json_parser/Makefile b/src/test/modules/test_json_parser/Makefile
new file mode 100644
index 0000000000..04350c68db
--- /dev/null
+++ b/src/test/modules/test_json_parser/Makefile
@@ -0,0 +1,36 @@
+
+PGFILEDESC = "standalone json parser tester"
+PGAPPICON = win32
+
+TAP_TESTS = 1
+
+OBJS = test_json_parser_incremental.o test_json_parser_perf.o
+
+ifdef USE_PGXS
+PG_CONFIG = pg_config
+PGXS := $(shell $(PG_CONFIG) --pgxs)
+include $(PGXS)
+else
+subdir = src/test/modules/test_json_parser
+top_builddir = ../../../..
+include $(top_builddir)/src/Makefile.global
+include $(top_srcdir)/contrib/contrib-global.mk
+endif
+
+all: test_json_parser_incremental$(X) test_json_parser_perf$(X)
+
+%.o: $(top_srcdir)/$(subdir)/%.c
+
+PARSER_LIBS = $(top_builddir)/src/common/libpgcommon.a $(top_builddir)/src/port/libpgport.a
+
+test_json_parser_incremental$(X): test_json_parser_incremental.o $(PARSER_LIBS)
+	$(CC) $(CFLAGS) $^ -o $@
+
+test_json_parser_perf$(X): test_json_parser_perf.o $(PARSER_LIBS)
+	$(CC) $(CFLAGS) $^ -o $@
+
+speed-check: test_json_parser_perf$(X)
+	@echo Standard parser:
+	time ./test_json_parser_perf 10000 $(top_srcdir)/$(subdir)/tiny.json
+	@echo Incremental parser:
+	time ./test_json_parser_perf -i 10000 $(top_srcdir)/$(subdir)/tiny.json
diff --git a/src/test/modules/test_json_parser/README b/src/test/modules/test_json_parser/README
new file mode 100644
index 0000000000..8241209380
--- /dev/null
+++ b/src/test/modules/test_json_parser/README
@@ -0,0 +1,26 @@
+Module `test_json_parser`
+=========================
+
+This module contains two programs for testing the json parsers.
+
+- `test_json_parser_incremental` is for testing the incremental parser, It
+  reads in a file and pases it in very small chunks (60 bytes at a time) to
+  the incremental parser. It's not meant to be a speed test but to test the
+  accuracy of the incremental parser. It takes one argument: the name of the
+  input file.
+- `test_json_parser_perf` is for speed testing both the standard
+  recursive descent parser and the non-recursive incremental
+  parser. If given the `-i` flag it uses the non-recursive parser,
+  otherwise the stardard parser. The remaining flags are the number of
+  parsing iterations and the file containing the input. Even when
+  using the non-recursive parser, the input is passed to the parser in a
+  single chunk. The results are thus comparable to those of the
+  standard parser.
+
+The easiest way to use these is to run `make check` and `make speed-check`
+
+The sample input file is a small extract from a list of `delicious`
+bookmarks taken some years ago, all wrapped in a single json
+array. 10,000 iterations of parsing this file gives a reasonable
+benchmark, and that is what the `speed-check` target does.
+
diff --git a/src/test/modules/test_json_parser/meson.build b/src/test/modules/test_json_parser/meson.build
new file mode 100644
index 0000000000..a5bedce94e
--- /dev/null
+++ b/src/test/modules/test_json_parser/meson.build
@@ -0,0 +1,50 @@
+# Copyright (c) 2024, PostgreSQL Global Development Group
+
+test_json_parser_incremental_sources = files(
+  'test_json_parser_incremental.c',
+)
+
+if host_system == 'windows'
+  test_json_parser_incremental_sources += rc_bin_gen.process(win32ver_rc, extra_args: [
+    '--NAME', 'test_json_parser_incremental',
+    '--FILEDESC', 'standalone json parser tester',
+  ])
+endif
+
+test_json_parser_incremental = executable('test_json_parser_incremental',
+  test_json_parser_incremental_sources,
+  dependencies: [frontend_code],
+  kwargs: default_bin_args + {
+    'install': false,
+  },
+)
+
+test_json_parser_perf_sources = files(
+  'test_json_parser_perf.c',
+)
+
+if host_system == 'windows'
+  test_json_parser_perf_sources += rc_bin_gen.process(win32ver_rc, extra_args: [
+    '--NAME', 'test_json_parser_perf',
+    '--FILEDESC', 'standalone json parser tester',
+  ])
+endif
+
+test_json_parser_perf = executable('test_json_parser_perf',
+  test_json_parser_perf_sources,
+  dependencies: [frontend_code],
+  kwargs: default_bin_args + {
+    'install': false,
+  },
+)
+
+tests += {
+  'name': 'test_json_parser',
+  'sd': meson.current_source_dir(),
+  'bd': meson.current_build_dir(),
+  'tap': {
+    'tests': [
+      't/001_test_json_parser_incremental.pl',
+    ],
+  },
+}
diff --git a/src/test/modules/test_json_parser/t/001_test_json_parser_incremental.pl b/src/test/modules/test_json_parser/t/001_test_json_parser_incremental.pl
new file mode 100644
index 0000000000..436ef98397
--- /dev/null
+++ b/src/test/modules/test_json_parser/t/001_test_json_parser_incremental.pl
@@ -0,0 +1,47 @@
+
+use strict;
+use warnings;
+
+use PostgreSQL::Test::Utils;
+use Test::More;
+use FindBin;
+
+use File::Temp qw(tempfile);
+
+my $test_file = "$FindBin::RealBin/../tiny.json";
+
+my $exe = "test_json_parser_incremental";
+
+my @inlinetests = ("false", "12345", '"a"', "[1,2]");
+
+for (my $size = 64; $size > 0; $size--)
+{
+	my ($stdout, $stderr) = run_command( [$exe, "-c", $size, $test_file] );
+
+	like($stdout, qr/SUCCESS/, "chunk size $size: test succeeds");
+	is($stderr, "", "chunk size $size: no error output");
+}
+
+foreach my $test_string (@inlinetests)
+{
+	my ($fh, $fname) = tempfile();
+	print $fh "$test_string";
+	close($fh);
+
+	foreach my $size (1..6, 10, 20, 30)
+	{
+		next if $size > length($test_string);
+
+		my ($stdout, $stderr) = run_command( [$exe, "-c", $size, $fname] );
+
+		like($stdout, qr/SUCCESS/, "chunk size $size, input '$test_string': test succeeds");
+		is($stderr, "", "chunk size $size, input '$test_string': no error output");
+	}
+}
+
+done_testing();
+
+
+
+
+
diff --git a/src/test/modules/test_json_parser/test_json_parser_incremental.c b/src/test/modules/test_json_parser/test_json_parser_incremental.c
new file mode 100644
index 0000000000..e2ca5ce9b3
--- /dev/null
+++ b/src/test/modules/test_json_parser/test_json_parser_incremental.c
@@ -0,0 +1,96 @@
+/*-------------------------------------------------------------------------
+ *
+ * test_json_parser_incremental.c
+ *    Test program for incremental JSON parser
+ *
+ * Copyright (c) 2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *    src/test/modules/test_json_parser/test_json_parser_incremental.c
+ *
+ * This progam tests incremental parsing of json. The input is fed into
+ * the parser in very small chunks. In practice you would normally use
+ * much larger chunks, but doing this makes it more likely that the
+ * full range of incement handling, especially in the lexer, is exercised.
+ * If the "-c SIZE" option is provided, that chunk size is used instead.
+ *
+ * The argument specifies the file containing the JSON input.
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres_fe.h"
+#include "common/jsonapi.h"
+#include "lib/stringinfo.h"
+#include "mb/pg_wchar.h"
+#include <stdio.h>
+#include <sys/types.h>
+#include <sys/stat.h>
+#include <unistd.h>
+
+int
+main(int argc, char **argv)
+{
+	/* max delicious line length is less than this */
+	char		buff[6001];
+	FILE	   *json_file;
+	JsonParseErrorType result;
+	JsonLexContext lex;
+	StringInfoData json;
+	int			n_read;
+	size_t		chunk_size = 60;
+	struct stat statbuf;
+	off_t       bytes_left;
+
+	if (strcmp(argv[1], "-c") == 0)
+	{
+		sscanf(argv[2], "%zu", &chunk_size);
+		argv += 2;
+	}
+
+	makeJsonLexContextIncremental(&lex, PG_UTF8, false);
+	initStringInfo(&json);
+
+	json_file = fopen(argv[1], "r");
+	fstat(fileno(json_file), &statbuf);
+	bytes_left = statbuf.st_size;
+	
+	for(;;)
+	{
+		n_read = fread(buff, 1, chunk_size, json_file);
+		appendBinaryStringInfo(&json, buff, n_read);
+		appendStringInfoString(&json, "1+23 trailing junk");
+		bytes_left -= n_read;
+		if (bytes_left > 0)
+		{
+			result = pg_parse_json_incremental(&lex, &nullSemAction,
+											   json.data, n_read,
+											   false);
+			if (result != JSON_INCOMPLETE)
+			{
+				fprintf(stderr,
+						"unexpected result %d (expecting %d) on token %s\n",
+						result, JSON_INCOMPLETE, lex.token_start);
+				exit(1);
+			}
+			resetStringInfo(&json);
+		}
+		else
+		{
+			result = pg_parse_json_incremental(&lex, &nullSemAction,
+											   json.data, n_read,
+											   true);
+			if (result != JSON_SUCCESS)
+			{
+				fprintf(stderr,
+						"unexpected result %d (expecting %d) on final chunk\n",
+						result, JSON_SUCCESS);
+				exit(1);
+			}
+			printf("SUCCESS!\n");
+			break;
+		}
+	}
+	fclose(json_file);
+	exit(0);
+}
diff --git a/src/test/modules/test_json_parser/test_json_parser_perf.c b/src/test/modules/test_json_parser/test_json_parser_perf.c
new file mode 100644
index 0000000000..517dc8529a
--- /dev/null
+++ b/src/test/modules/test_json_parser/test_json_parser_perf.c
@@ -0,0 +1,86 @@
+/*-------------------------------------------------------------------------
+ *
+ * test_json_parser_perf.c
+ *    Performancet est program for both flavors of the JSON parser
+ *
+ * Copyright (c) 2023, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *    src/test/modules/test_json_parser/test_json_parser_perf.c
+ *
+ * This progam tests either the standard (recursive descent) JSON parser
+ * or the incremental (table driven) parser, but without breaking the input
+ * into chunks in the latter case. Thus it can be used to compare the pure
+ * parsing speed of the two parsers. If the "-i" option is used, then the
+ * table driven parser is used. Otherwise, the recursive descent parser is
+ * used.
+ *
+ * The remaining arguments are the number of parsing iterations to be done
+ * and the file containing the JSON input.
+ *
+ *-------------------------------------------------------------------------
+ */
+
+#include "postgres_fe.h"
+#include "common/jsonapi.h"
+#include "lib/stringinfo.h"
+#include "mb/pg_wchar.h"
+#include <stdio.h>
+#include <string.h>
+
+int
+main(int argc, char **argv)
+{
+	/* max delicious line length is less than this */
+	char		buff[6001];
+	FILE	   *json_file;
+	JsonParseErrorType result;
+	JsonLexContext *lex;
+	StringInfoData json;
+	int			n_read;
+	int			iter;
+	int			use_inc = 0;
+
+	initStringInfo(&json);
+
+	if (strcmp(argv[1], "-i") == 0)
+	{
+		use_inc = 1;
+		argv++;
+	}
+
+	sscanf(argv[1], "%d", &iter);
+
+	json_file = fopen(argv[2], "r");
+	while ((n_read = fread(buff, 1, 6000, json_file)) > 0)
+	{
+		appendBinaryStringInfo(&json, buff, n_read);
+	}
+	fclose(json_file);
+	for (int i = 0; i < iter; i++)
+	{
+		if (use_inc)
+		{
+			lex = makeJsonLexContextIncremental(NULL, PG_UTF8, false);
+			result = pg_parse_json_incremental(lex, &nullSemAction,
+											   json.data, json.len,
+											   true);
+			freeJsonLexContext(lex);
+		}
+		else
+		{
+			lex = makeJsonLexContextCstringLen(NULL, json.data, json.len,
+											   PG_UTF8, false);
+			result = pg_parse_json(lex, &nullSemAction);
+			freeJsonLexContext(lex);
+		}
+		if (result != JSON_SUCCESS)
+		{
+			fprintf(stderr,
+					"unexpected result %d (expecting %d) on parse\n",
+					result, JSON_SUCCESS);
+			exit(1);
+		}
+	}
+	exit(0);
+}
diff --git a/src/tools/pgindent/typedefs.list b/src/tools/pgindent/typedefs.list
index d3a7f75b08..c70fee3aac 100644
--- a/src/tools/pgindent/typedefs.list
+++ b/src/tools/pgindent/typedefs.list
@@ -1280,6 +1280,7 @@ JsonEncoding
 JsonFormat
 JsonFormatType
 JsonHashEntry
+JsonIncrementalState
 JsonIsPredicate
 JsonIterateStringValuesAction
 JsonKeyValue
@@ -1287,15 +1288,19 @@ JsonLexContext
 JsonLikeRegexContext
 JsonManifestFileField
 JsonManifestParseContext
+JsonManifestParseIncrementalState
 JsonManifestParseState
 JsonManifestSemanticState
 JsonManifestWALRangeField
+JsonNonTerminal
 JsonObjectAgg
 JsonObjectConstructor
 JsonOutput
 JsonParseExpr
 JsonParseContext
 JsonParseErrorType
+JsonParserSem
+JsonParserStack
 JsonPath
 JsonPathBool
 JsonPathExecContext
-- 
2.34.1

